




// **********************************************
//     Geraete_Manager
// **********************************************




procedure direkt_CONOUT_to_Device;
begin

  case CONOUT_Device_NR1 of

  Device_Serial : UART_CONOUT_senden;
  |

  Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                    ITP3_sende_CONOUT(ConsoleOut);
  |

  Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                    ITP3_sende_CONOUT(ConsoleOut);
  |

  Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                    ITP3_sende_CONOUT(ConsoleOut);
  |

  Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                    ITP3_sende_CONOUT(ConsoleOut);
  |

  Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                    ITP3_sende_CONOUT(ConsoleOut);
  |

  endcase;

  if CONOUT_Device_NR2<>no_Device then

    case CONOUT_Device_NR2 of

      Device_Serial : UART_CONOUT_senden;
      |

      Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                        ITP3_sende_CONOUT(ConsoleOut);
      |

      Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                        ITP3_sende_CONOUT(ConsoleOut);
      |

      Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                        ITP3_sende_CONOUT(ConsoleOut);
      |

      Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                        ITP3_sende_CONOUT(ConsoleOut);
      |

      Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                        ITP3_sende_CONOUT(ConsoleOut);
      |

    endcase;

  endif;

end direkt_CONOUT_to_Device;








// **********************************************





procedure Anzeige_String_an_CONOUT;

var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
begin

  Laenge:=Length(Anzeige_String);
  for b1:=1 to Laenge do
    c1:=Anzeige_String[b1];
    ConsoleOut:=CharToByte(c1);
    direkt_CONOUT_to_Device;
  endfor;

  ConsoleOut:=CR;
  direkt_CONOUT_to_Device;

  ConsoleOut:=LF;
  direkt_CONOUT_to_Device;

end Anzeige_String_an_CONOUT;





// *** Laufwerke - Verteiler ***




procedure INIT_Laufwerke_Verteiler;
var
  LV_Zeiger : Word;
begin

  for LV_Zeiger:=0 to 15 do
    Laufwerke_Verteiler[LV_Zeiger]:=no_Device;
  endfor;

end INIT_Laufwerke_Verteiler;







procedure Laufwerke_Verteiler_nach_oben_kopieren;
var
  LV_Zeiger : Word;
  LV_Zeiger_M1 : Word;
  es_wurde_kopiert : Boolean;
  Eintrag_Wert : Byte;
  Eintrag_Wert_M1 : Byte;

begin

  es_wurde_kopiert:=true;

  while es_wurde_kopiert do

    es_wurde_kopiert:=false;

    for LV_Zeiger:=15 downto 1 do

      Eintrag_Wert:=Laufwerke_Verteiler[LV_Zeiger];

      if Eintrag_Wert=no_Device then

        LV_Zeiger_M1:=LV_Zeiger-1;
        Eintrag_Wert_M1:=Laufwerke_Verteiler[LV_Zeiger_M1];

        if Eintrag_Wert_M1<>no_Device then

          Laufwerke_Verteiler[LV_Zeiger]:=Eintrag_Wert_M1;
          Laufwerke_Verteiler[LV_Zeiger_M1]:=no_Device;
          es_wurde_kopiert:=true;

        endif;

      endif;

    endfor;

  endwhile;

end Laufwerke_Verteiler_nach_oben_kopieren;








procedure Laufwerke_Verteiler_nach_unten_kopieren;
var
  LV_Zeiger : Word;
  LV_Zeiger_P1 : Word;
  es_wurde_kopiert : Boolean;
  Eintrag_Wert : Byte;
  Eintrag_Wert_P1 : Byte;

begin

  es_wurde_kopiert:=true;

  while es_wurde_kopiert do

    es_wurde_kopiert:=false;

    for LV_Zeiger:=0 to 14 do

      Eintrag_Wert:=Laufwerke_Verteiler[LV_Zeiger];

      if Eintrag_Wert=no_Device then

        LV_Zeiger_P1:=LV_Zeiger+1;
        Eintrag_Wert_P1:=Laufwerke_Verteiler[LV_Zeiger_P1];

        if Eintrag_Wert_P1<>no_Device then

          Laufwerke_Verteiler[LV_Zeiger]:=Eintrag_Wert_P1;
          Laufwerke_Verteiler[LV_Zeiger_P1]:=no_Device;
          es_wurde_kopiert:=true;

        endif;

      endif;

    endfor;

  endwhile;

end Laufwerke_Verteiler_nach_unten_kopieren;







procedure Laufwerke_Verteiler_anzeigen;
var
  LV_Zeiger : Word;
  Eintrag_Wert : Byte;
  LW_Buchstabe_Byte : Byte;
  LW_Buchstabe_Char : Char;
begin

  LW_Buchstabe_Byte:=$41;

  for LV_Zeiger:=0 to 15 do
    Eintrag_Wert:=Laufwerke_Verteiler[LV_Zeiger];
    if Eintrag_Wert<>no_Device then
      LW_Buchstabe_Char:=ByteToChar(LW_Buchstabe_Byte);
      Anzeige_String:=LW_Buchstabe_Char+': -> ';

      case Eintrag_Wert of

        Device_lokal_Flash : Anzeige_String:=Anzeige_String+'lokal Flash';
        |

        Device_Serial : Anzeige_String:=Anzeige_String+'Serial';
        |

        Device_ITP3_DS0 : Anzeige_String:=Anzeige_String+'ITP3 DS0';
        |

        Device_ITP3_DS1 : Anzeige_String:=Anzeige_String+'ITP3 DS1';
        |

        Device_ITP3_DS2 : Anzeige_String:=Anzeige_String+'ITP3 DS2';
        |

        Device_ITP3_DS3 : Anzeige_String:=Anzeige_String+'ITP3 DS3';
        |

        Device_ITP3_DS4 : Anzeige_String:=Anzeige_String+'ITP3 DS4';
        |

      endcase;

      Anzeige_String_an_CONOUT;

    endif;
    INC(LW_Buchstabe_Byte);
  endfor;

end Laufwerke_Verteiler_anzeigen;







procedure Geraete_anzeigen_Device(CON_Device : Byte);
begin

  case CON_Device of

  Device_lokal_Flash : Anzeige_String:=Anzeige_String+'lokal Flash';
  |

  Device_Serial : Anzeige_String:=Anzeige_String+'Serial';
  |

  Device_ITP3_DS0 : Anzeige_String:=Anzeige_String+'ITP3 DS0';
  |

  Device_ITP3_DS1 : Anzeige_String:=Anzeige_String+'ITP3 DS1';
  |

  Device_ITP3_DS2 : Anzeige_String:=Anzeige_String+'ITP3 DS2';
  |

  Device_ITP3_DS3 : Anzeige_String:=Anzeige_String+'ITP3 DS3';
  |

  Device_ITP3_DS4 : Anzeige_String:=Anzeige_String+'ITP3 DS4';
  |

  endcase;

end Geraete_anzeigen_Device;





procedure Geraete_anzeigen;
begin


  if I2C_vorhanden then
  else
    Anzeige_String:='*** kein lokaler Flash (AT24C512) erkannt ***';
    Anzeige_String_an_CONOUT;
  endif;



  if CONOUT_Device_NR2=no_Device then
    Anzeige_String:='CONOUT=';
    Geraete_anzeigen_Device(CONOUT_Device_NR1);
    Anzeige_String_an_CONOUT;
  else
    Anzeige_String:='CONOUT_NR1=';
    Geraete_anzeigen_Device(CONOUT_Device_NR1);
    Anzeige_String_an_CONOUT;
    Anzeige_String:='CONOUT_NR2=';
    Geraete_anzeigen_Device(CONOUT_Device_NR2);
    Anzeige_String_an_CONOUT;
  endif;

  Anzeige_String:='CONIN=';
  Geraete_anzeigen_Device(CONIN_Device);
  Anzeige_String_an_CONOUT;


  if SOUND_Device<>no_Device then
    Anzeige_String:='SOUND=';
    Geraete_anzeigen_Device(SOUND_Device);
    Anzeige_String_an_CONOUT;
  endif;

end Geraete_anzeigen;









function DISKNO_in_Schnittstelle : Byte;
var
  Eintrag_Wert : Byte;
  Laufwerk_Word : Word;
begin
  Laufwerk_Word:=ByteToWord(DISKNO);
  Eintrag_Wert:=Laufwerke_Verteiler[Laufwerk_Word];
  Result:=Eintrag_Wert;

end DISKNO_in_Schnittstelle;






procedure Laufwerke_Verteiler_READ;
var
  Eintrag_Wert : Byte;
begin

    Eintrag_Wert:=DISKNO_in_Schnittstelle;

    case Eintrag_Wert of

      Device_lokal_Flash : STD_an_lokalen_FLASH_Manager_senden;
                           lokalen_FLASH_Manager_Sektor_lesen;
      |

      Device_Serial : STD_an_UART_senden;
                      Sektor_von_UART_lesen_Komp;
                      // Sektor_von_UART_lesen;
      |

      Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                        ITP3_sende_STD;
                        ITP3_Sektor_lesen;
      |

      Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                        ITP3_sende_STD;
                        ITP3_Sektor_lesen;
      |

      Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                        ITP3_sende_STD;
                        ITP3_Sektor_lesen;
      |

      Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                        ITP3_sende_STD;
                        ITP3_Sektor_lesen;
      |

      Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                        ITP3_sende_STD;
                        ITP3_Sektor_lesen;
      |

    endcase;


end Laufwerke_Verteiler_READ;








procedure Laufwerke_Verteiler_WRITE;
var
  Eintrag_Wert : Byte;
begin

  Eintrag_Wert:=DISKNO_in_Schnittstelle;

  case Eintrag_Wert of

      Device_lokal_Flash : STD_an_lokalen_FLASH_Manager_senden;
                           lokalen_FLASH_Manager_Sektor_schreiben;
      |

      Device_Serial : STD_an_UART_senden;
                      Sektor_an_UART_senden;
      |

      Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                        ITP3_sende_STD;
                        ITP3_Sektor_schreiben;
      |

      Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                        ITP3_sende_STD;
                        ITP3_Sektor_schreiben;
      |

      Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                        ITP3_sende_STD;
                        ITP3_Sektor_schreiben;
      |

      Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                        ITP3_sende_STD;
                        ITP3_Sektor_schreiben;
      |

      Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                        ITP3_sende_STD;
                        ITP3_Sektor_schreiben;
      |

    endcase;


end Laufwerke_Verteiler_WRITE;
















